<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/include/ThreadManagerPowerSaver.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_thread_manager_power_saver_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">ThreadManagerPowerSaver.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;ThreadManager.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;MTQueue.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;MTSignatures.h&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classsiggen_1_1_thread_manager_power_saver.html">   16</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classsiggen_1_1_thread_manager_power_saver.html">ThreadManagerPowerSaver</a> : <span class="keyword">public</span> <a class="code" href="classsiggen_1_1_thread_manager.html">ThreadManager</a></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    {</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        std::atomic&lt;bool&gt; m_Terminate { <span class="keyword">false</span> };            </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        std::vector&lt;char&gt; m_Block;                          </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <a class="code" href="classsiggen_1_1_m_t_queue.html">MTQueue</a> m_Queue;                                    </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <a class="code" href="classsiggen_1_1_m_t_signatures.html">MTSignatures</a> m_Signatures;                          </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        std::vector&lt;std::thread&gt; m_Threads;                 </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">ConsumerThread</a> (<span class="keywordtype">size_t</span> threadIndex);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#a2434e6d1fc566048154d81380065df1e">ThreadManagerPowerSaver</a> (<a class="code" href="structsiggen_1_1_data.html">Data</a> &amp;&amp; data);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="classsiggen_1_1_thread_manager_power_saver.html">ThreadManagerPowerSaver</a> ();</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">ProcessToBuffer</a> (std::vector&lt;char&gt; &amp; result) <span class="keyword">override</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    };</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_m_t_signatures_html"><div class="ttname"><a href="classsiggen_1_1_m_t_signatures.html">siggen::MTSignatures</a></div><div class="ttdoc">thread-safe buffer for resulting block-wise signatures</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_signatures_8h_source.html#l00011">MTSignatures.h:11</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html_a2434e6d1fc566048154d81380065df1e"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html#a2434e6d1fc566048154d81380065df1e">siggen::ThreadManagerPowerSaver::ThreadManagerPowerSaver</a></div><div class="ttdeci">ThreadManagerPowerSaver(Data &amp;&amp;data)</div><div class="ttdoc">spawns data.m_ThreadCount threads to do the work</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8cpp_source.html#l00008">ThreadManagerPowerSaver.cpp:8</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html_ac96e31c7a171d9309dcb04b4232cec58"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html#ac96e31c7a171d9309dcb04b4232cec58">siggen::ThreadManagerPowerSaver::ProcessToBuffer</a></div><div class="ttdeci">virtual void ProcessToBuffer(std::vector&lt; char &gt; &amp;result) override</div><div class="ttdoc">reads a block of data from input file, and enqueues the data for further processing by threads</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8cpp_source.html#l00064">ThreadManagerPowerSaver.cpp:64</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_html"><div class="ttname"><a href="classsiggen_1_1_thread_manager.html">siggen::ThreadManager</a></div><div class="ttdoc">common implementation of a ThreadManager base</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_8h_source.html#l00011">ThreadManager.h:11</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html">siggen::MTQueue</a></div><div class="ttdoc">synchronized data passing between producer and consumer threads</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8h_source.html#l00016">MTQueue.h:16</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html">siggen::ThreadManagerPowerSaver</a></div><div class="ttdoc">default thread manager using mutexes and condition variables</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8h_source.html#l00016">ThreadManagerPowerSaver.h:16</a></div></div>
<div class="ttc" id="astructsiggen_1_1_data_html"><div class="ttname"><a href="structsiggen_1_1_data.html">siggen::Data</a></div><div class="ttdoc">provides threading manager with necessary data to work with</div><div class="ttdef"><b>Definition:</b> <a href="_data_8h_source.html#l00012">Data.h:12</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_thread_manager_power_saver_html_a26a2a10c5fa543ea86c5058d69e0ee87"><div class="ttname"><a href="classsiggen_1_1_thread_manager_power_saver.html#a26a2a10c5fa543ea86c5058d69e0ee87">siggen::ThreadManagerPowerSaver::ConsumerThread</a></div><div class="ttdeci">void ConsumerThread(size_t threadIndex)</div><div class="ttdoc">basic loop for spawned consumer threads</div><div class="ttdef"><b>Definition:</b> <a href="_thread_manager_power_saver_8cpp_source.html#l00028">ThreadManagerPowerSaver.cpp:28</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_5a30104352ef4255dc24354b02eb2d20.html">include</a></li><li class="navelem"><b>ThreadManagerPowerSaver.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
